      subroutine archivnc(n, kkout, iyear,iday,ihour, intvl,dtime0)
c
c     subroutine archivnc.f writes netcdf files as output instead of HYCOm 2.x style .[ab]. 
c     all variables in a usual HYCOM 2.x type archive are written to the netcdf file.
c     curvilinear grids are not supported in this version
c     parallel IO not supported in this version
c     Ashwanth Srinivasan - 08/02/2009.


      use mod_xc  ! HYCOM communication interface
      use mod_za  ! HYCOM I/O interface
      implicit none
c
      include 'common_blocks.h'
c
      integer   n, kkout, iyear,iday,ihour,i,j
      real      sssc,sstc
      real*8    dtime0
      real*4    time0
      character intvl*3, fname*240
      character*80 cformat
      integer      k,ktr,l,nop
      real         coord,xmin,xmax
      real,dimension(itdm,jtdm) :: ptlat,ptlon,utlat,utlon,vtlat,vtlon
      real*4,dimension(itdm,jtdm) :: r4ptlat,r4ptlon,r4utlat,r4utlon
      real*4,dimension(itdm,jtdm) ::r4vtlat,r4vtlon
c
      l = index(flnmarc(1:48-11),'.')  ! need 11 characters for archive date
      if     (l.eq.0) then
        if     (mnproc.eq.1) then
        write (lp,*) 'need decimal point in flnmarc'
        write (lp,*) 'flnmarc = ',flnmarc(1:len_trim(flnmarc))
        endif
        call xcstop('(flnmarc)')
               stop '(flnmarc)'
      endif
c
      if     ((kkout.eq.1 .and. dsurfq.ge.1.0/24.0) .or.
     &        (kkout.gt.1 .and. diagfq.ge.1.0/24.0)     ) then
c ---   indicate the archive date
        write(flnmarc(l+1:l+11),'(i4.4,a1,i3.3,a1,i2.2)')
     &   iyear,'_',iday,'_',ihour
        l=l+11
      else
c ---   indicate the archive time step
        write(flnmarc(l+1:l+11),'(i11.11)') nstep
        l=l+11
      endif
      nop=13
      time0=dtime0

         
      call xcaget(ptlon,plon,1)
      call xcaget(ptlat,plat,1)

      call xcaget(utlon,ulon,1)
      call xcaget(utlat,ulat,1)

      call xcaget(vtlon,vlon,1)
      call xcaget(vtlat,vlat,1)

c
c --- no .[ab] files for 1-D cases (<=6x6).
c
      if     (max(itdm,jtdm).gt.6) then  !not 1-D
c
      if     (mnproc.eq.1) then

       fname=flnmarc(1:l)//'.nc'
       r4ptlon=ptlon
       r4ptlat=ptlat
       r4utlon=utlon
       r4utlat=utlat
       r4vtlon=vtlon
       r4vtlat=vtlat 

        call nciopn(fname,r4ptlon,r4ptlat,
     &  r4utlon,r4utlat,r4vtlon,r4vtlat,
     &  itdm,jtdm,kdm,sigma,time0)

       endif

! write 2d variables

        call nciowr(montg(:,:,1,n),ip,.true.,fname,'montg1')
        call nciowr(srfhgt,ip,.true.,fname,'ssh') 

        call nciowr(salflx,ip,.true.,fname,'salflx')
        call nciowr(surflx,ip,.true.,fname,'surflx')

        call nciowr(dpbl,ip,.true.,fname,'dpbl')
        call nciowr(dpmixl,ip,.true.,fname,'dpmixl')

        call nciowr(tmix,ip,.true.,fname,'tmix')
        call nciowr(smix,ip,.true.,fname,'smix')

        call nciowr(umix,iu,.true.,fname,'umix')
        call nciowr(vmix,iv,.true.,fname,'vmix')

! write depth averaged variables

        call nciowr(ubavg(:,:,n),iu,.true.,fname,'ubaro')
        call nciowr(vbavg(:,:,n),iv,.true.,fname,'vbaro')

! write 3d variables

        call nciowr3(u(:,:,:,n),iu,.true.,fname,'u')
        call nciowr3(v(:,:,:,n),iv,.true.,fname,'v')
        call nciowr3(dp(:,:,:,n),ip,.true.,fname,'dp')
        call nciowr3(temp(:,:,:,n),ip,.true.,fname,'temp')
        call nciowr3(saln(:,:,:,n),ip,.true.,fname,'saln')
        call nciowr3(th3d(:,:,:,n),ip,.true.,fname,'th3d')


        endif
          
        end subroutine
