         subroutine bacln_pert(dtime,lslot)
         use netcdf
         use mod_xc  ! HYCOM communication interface
         use mod_za  ! HYCOM I/O interface
         implicit none
         include 'common_blocks.h'

         character(255) :: cfile,pcfile
!        data set related variables
       
         integer,parameter  :: nxt=541
         integer,parameter  :: nyt=385
         integer,parameter  :: nx_real=239
         integer,parameter  :: ny_real=11
         integer,parameter  :: nz_real=20
         integer,parameter  :: ntime=1
         integer,parameter  :: n3d=5
         integer,parameter  :: n2d=2
         integer,parameter  :: nmodes=2
         integer,parameter  :: istart=256
         integer,parameter  :: iend=istart+nx_real-1
!        netcdf data related variables

         integer :: status,sncid,svarid,varid

         real*8,allocatable  :: otnest(:,:,:)
         real*8,allocatable  :: osnest(:,:,:)
         real*8,allocatable  :: opnest(:,:,:)
         real*8,allocatable  :: ounest(:,:,:)
         real*8,allocatable  :: ovnest(:,:,:)
         real*4,parameter    :: spval=2.00**100
!        data matrix related variables

         real*8,allocatable  :: prtb(:,:)
         real*8,dimension(2) :: zeta
! EOF related variables:


         integer  nx2d
         integer  nx3d
         integer  nx 
         integer  nt

         real*8,allocatable  ::  eigenvectors(:,:)
         real*8,allocatable  ::  princomp(:,:)
         real*8              ::  xxsum,xxsumi
         real*8              ::  dtime
c        misc variables

         integer vpt,len,lslot,l,n,i,j,k

         character  pcflnm*22
         integer   iyear,iday,ihour
c
      call forday(dtime, yrflag, iyear,iday,ihour)
c
      write(pcflnm,'("nest/pc.",i4.4,"_",i3.3,"_",i2.2,".nc")')
     &                           iyear,iday,ihour

!       c...   allocate the required arrays
        n=1

       allocate(otnest(nxt,nyt,nz_real))
       allocate(osnest(nxt,nyt,nz_real))
       allocate(ounest(nxt,nyt,nz_real))
       allocate(ovnest(nxt,nyt,nz_real))
       allocate(opnest(nxt,nyt,nz_real+1))

       opnest=0.0           
       osnest=0.0
       otnest=0.0
       ounest=0.0
       ovnest=0.0

       do k=1,nz_real

       call xcaget(ounest(:,:,k),unest(1-nbdy,1-nbdy,k,lslot),1)
       call xcaget(ovnest(:,:,k),vnest(1-nbdy,1-nbdy,k,lslot),1)
       call xcaget(opnest(:,:,k),pnest(1-nbdy,1-nbdy,k,lslot),1)
       call xcaget(otnest(:,:,k),tnest(1-nbdy,1-nbdy,k,lslot),1)      
       call xcaget(osnest(:,:,k),snest(1-nbdy,1-nbdy,k,lslot),1)

       enddo


      if     (mnproc.eq.1) then
      write (lp,*) 'baclin_pc_in: ',pcflnm
      print *,"old value at test pt: ",
     & ounest(257,1,1), ovnest(258,2,1),opnest(257,1,10),otnest(257,1,1)

       
       open(15,file="uqruns")
       do i=1,nrlz
       READ(15,*) zeta(1),zeta(2)
       enddo
       close(15)


       print *, "Realization: ", nrlz 
       print *, "Stochastic Parameters: ", zeta
       print *, "No of Modes: 2"
c...   allocate all required arrays and form the data matrix
 
       nx2d=n2d*nx_real*ny_real
       nx3d=n3d*(nx_real*ny_real*nz_real)
       nx=nx3d+nx2d
       nt=1

c...   data is 2 fields
      
       allocate (prtb(nx,nt))
       allocate (eigenvectors(nx,nmodes))
       allocate (princomp(nt,nmodes))
      
       prtb=0.0
       eigenvectors=0.0
       princomp=0.0

!      read EOF
       call ncheck(nf90_open("nest/evectors.nc", nf90_Write, sncid))
       call ncheck(nf90_inq_varid(sncid, "evectors", svarid))
       call ncheck(nf90_get_var(sncid,svarid,eigenvectors))

!      read Princomp

       call ncheck(nf90_open(trim(pcflnm), nf90_Write, sncid))
       call ncheck(nf90_inq_varid(sncid, "pc", varid))
       call ncheck(nf90_get_var(sncid,varid,princomp))

         
           do j=1,nt
           do i=1,nx
            do k=1,nmodes
              if(eigenvectors(i,k) .ne. spval) then
        prtb(i,j)=prtb(i,j)+ eigenvectors(i,k)*princomp(j,k)*zeta(k)
              else
             prtb(i,j)=0.0
               endif
         enddo
         enddo
        enddo


         vpt=0
         do k=1,nz_real
         do j=1,ny_real
         do i=istart,iend
         vpt=vpt+1
          if(abs(eigenvectors(vpt,1)-spval)>1.0) then
          otnest(i,j,k)= otnest(i,j,k)+prtb(vpt,1)
          osnest(i,j,k)= osnest(i,j,k)+prtb(nx3d/n3d+vpt,1)
          opnest(i,j,k+1)=opnest(i,j,k+1)+prtb(2*nx3d/n3d+vpt,1)
          ounest(i,j,k)=ounest(i,j,k)+prtb(3*nx3d/n3d+vpt,1)
          ovnest(i,j,k)=ovnest(i,j,k)+prtb(4*nx3d/n3d+vpt,1)
          endif
         enddo
        enddo
       enddo

!        clean up dp's
        
        do j=1,ny_real
         do i=istart,iend

! 1st pass

         do l = 1, nz_real-1
            k=l+1
            if(opnest(i,j,k) .ne.spval) then
            opnest(i,j,k+1)=opnest(i,j,k+1)+min(0.0,opnest(i,j,k))
            opnest(i,j,k)=max(opnest(i,j,k),0.0)
            endif
         end do

! 2nd pass

         do l = nz_real, 3, -1
             k=l+1
             if(opnest(i,j,k) .ne. spval) then
            opnest(i,j,k-1)=opnest(i,j,k-1)+min(0.0,opnest(i,j,k))
            opnest(i,j,k)=max(opnest(i,j,k),0.0)
             endif
         end do

         enddo
         enddo

!       end clean up dp's



        print *,"perturbed value at test pt: ",
     &  ounest(257,1,1), ovnest(258,2,1),opnest(257,1,10),
     &  otnest(257,1,1)
        
!        xxsum=0.0;xxsumi=0.0 
!        do k=1,nz_real
!        print *, k, opnest(257,1,k)/9806.! rdp(2,1,k)/9806.
!        xxsum=xxsum+opnest(257,1,k)/9806.
!        xxsumi=xxsumi+rdp(2,1,k)/9806.
!        enddo
!        print *, xxsum

       deallocate (prtb)
       deallocate (eigenvectors)
       deallocate (princomp)

        endif !mnproc.eq.1

         do k=1,nz_real

       call xcaput(ounest(:,:,k),unest(1-nbdy,1-nbdy,k,lslot),1)
       call xcaput(ovnest(:,:,k),vnest(1-nbdy,1-nbdy,k,lslot),1)
       call xcaput(opnest(:,:,k),pnest(1-nbdy,1-nbdy,k,lslot),1)
       call xcaput(otnest(:,:,k),tnest(1-nbdy,1-nbdy,k,lslot),1)
       call xcaput(osnest(:,:,k),snest(1-nbdy,1-nbdy,k,lslot),1)

       enddo

       deallocate(otnest)
       deallocate(osnest)
       deallocate(ounest)
       deallocate(ovnest)
       deallocate(opnest)
       end subroutine bacln_pert
