         subroutine baro_pert(dtime,lslot)
         use netcdf
         use mod_xc  ! HYCOM communication interface
         use mod_za  ! HYCOM I/O interface
         implicit none
         include 'common_blocks.h'

         character(255) :: cfile,pcfile
!        data set related variables
         integer,parameter  :: nxt=541
         integer,parameter  :: nyt=385
         integer,parameter  :: nx_real=239
         integer,parameter  :: ny_real=11
         integer,parameter  :: nz_real=20
         integer,parameter  :: n3d=5
         integer,parameter  :: n2d=2
         integer,parameter  :: nmodes=2
         integer,parameter  :: istart=256
         integer,parameter  :: iend=istart+nx_real-1
!        netcdf data related variables

         integer :: status,sncid,svarid,varid

         real*8,allocatable  :: oubavg(:,:)
         real*8,allocatable  :: ovbavg(:,:)
         real*4,parameter    :: spval=2.00**100
!        data matrix related variables

         real*8,allocatable  :: prtb(:,:)
         real*8,dimension(2) :: zeta

! EOF related variables:

         integer  nx2d
         integer  nx3d
         integer  nx 
         integer  nt

         real*8,allocatable  ::  eigenvectors(:,:)
         real*8,allocatable  ::  princomp(:,:)
         real*8              ::  dtime
c        misc variables

         integer vpt,len,lslot,l,n,i,j,k
         character  pcflnm*22
         integer   iyear,iday,ihour
c
      call forday(dtime, yrflag, iyear,iday,ihour)
c
      write(pcflnm,'("nest/pc.",i4.4,"_",i3.3,"_",i2.2,".nc")')
     &                           iyear,iday,ihour

!       c...   allocate the required arrays
        n=1
       allocate(oubavg(nxt,nyt))
       allocate(ovbavg(nxt,nyt))

      call xcaget(oubavg,ubnest(1-nbdy,1-nbdy,lslot),1)
      call xcaget(ovbavg,vbnest(1-nbdy,1-nbdy,lslot),1)
      
      if     (mnproc.eq.1) then
      write (lp,*) 'baro_pc_in: ',pcflnm
      print *, "old value at test pt: ", oubavg(257,1),ovbavg(257,2)
 
       open(15,file="uqruns")
       do i=1,nrlz
       READ(15,*) zeta(1),zeta(2)
       enddo
       close(15)
      
 
       print *, "Realization: ", nrlz 
       print *, "Stochastic Parameters: ", zeta
       print *, "No of Modes: 2"
c...   allocate all required arrays and form the data matrix
 
       nx2d=n2d*nx_real*ny_real
       nx3d=n3d*(nx_real*ny_real*nz_real)

       nx=nx3d+nx2d

       nt=1

c...   data is 2 fields
      
       allocate (prtb(nx,nt))
       allocate (eigenvectors(nx,nmodes))
       allocate (princomp(nt,nmodes))


!      read EOF
       call ncheck(nf90_open("nest/evectors.nc", nf90_Write, sncid))
       call ncheck(nf90_inq_varid(sncid, "evectors", svarid))
       call ncheck(nf90_get_var(sncid,svarid,eigenvectors))

!      read Princomp

       call ncheck(nf90_open(trim(pcflnm), nf90_Write, sncid))
       call ncheck(nf90_inq_varid(sncid, "pc", varid))
       call ncheck(nf90_get_var(sncid,varid,princomp))

         prtb(:,:)=0.0 
         do j=1,nt
           do i=1,nx
             do k=1,nmodes
             if(eigenvectors(i,k) .ne. spval) then
         prtb(i,j) = prtb(i,j)+ eigenvectors(i,k)*princomp(j,k)*
     & zeta(k)
             else
             prtb(i,j)=0.0
             endif

           enddo
         enddo
        enddo

  
         vpt=nx3d
         do j=1,ny_real
         do i=istart,iend
         vpt=vpt+1
          oubavg(i,j)=oubavg(i,j)+prtb(vpt,1)
          ovbavg(i,j)=ovbavg(i,j)+prtb(nx2d/n2d+vpt,1)
         enddo
        enddo
        
        print *,"perturbed value at test pt: ",
     &   oubavg(257,1), ovbavg(257,2)

       deallocate (prtb)
       deallocate (eigenvectors)
       deallocate (princomp)

        
        endif !mnproc.eq.1


        call xcaput(oubavg,ubnest(1-nbdy,1-nbdy,lslot),1)
        call xcaput(ovbavg,vbnest(1-nbdy,1-nbdy,lslot),1)

       
       deallocate(oubavg)
       deallocate(ovbavg)

     
       end subroutine baro_pert
