         subroutine restart_pert(dtime)
         use netcdf
         use mod_xc  ! HYCOM communication interface
         use mod_za  ! HYCOM I/O interface
         implicit none
         include 'common_blocks.h'

         character(255) :: cfile,pcfile
!        data set related variables
       
         integer,parameter  :: nxt=541
         integer,parameter  :: nyt=385
         integer,parameter  :: nx_real=541
         integer,parameter  :: ny_real=385
         integer,parameter  :: nz_real=20
         integer,parameter  :: ntime=1
         integer,parameter  :: n3d=5
         integer,parameter  :: n2d=2
         integer,parameter  :: nmodes=2
!        netcdf data related variables

         integer :: status,sncid,svarid,varid

         real*4,allocatable  :: rtemp(:,:,:,:)
         real*4,allocatable  :: rsaln(:,:,:,:)
         real*4,allocatable  :: rdp(:,:,:,:)
         real*4,allocatable  :: ruvel(:,:,:,:)
         real*4,allocatable  :: rvvel(:,:,:,:)

         real,allocatable  :: otemp(:,:,:)
         real,allocatable  :: osaln(:,:,:)
         real,allocatable  :: odp(:,:,:)
         real,allocatable  :: ouvel(:,:,:)
         real,allocatable  :: ovvel(:,:,:)

         real,allocatable  :: ptemp(:,:,:)
         real,allocatable  :: psaln(:,:,:)
         real,allocatable  :: pdp(:,:,:)
         real,allocatable  :: puvel(:,:,:)
         real,allocatable  :: pvvel(:,:,:)

         real,parameter    :: spval=2.00**100, hspval=0.5*spval

!        data matrix related variables

         real,dimension(2) :: zeta
! EOF related variables:

         real*8,allocatable  ::  princomp(:,:)
         real*8              ::  xxsum,xxsumi
         real*8              ::  dtime
c        misc variables

         integer vpt,len,lslot,l,n,i,j,k

         character  pcflnm*22, evecfile*22
         integer   iyear,iday,ihour
c
      call forday(dtime, yrflag, iyear,iday,ihour)
      evecfile="nest/evectors.nc"
      write(pcflnm,'("nest/pc.",i4.4,"_",i3.3,"_",i2.2,".nc")')
     &                           iyear,iday,ihour
!       c...   allocate the required arrays
        lslot=1

       allocate(rtemp(nx_real,ny_real,nz_real,nmodes))
       allocate(rsaln(nx_real,ny_real,nz_real,nmodes))
       allocate(rdp(nx_real,ny_real,nz_real,nmodes))
       allocate(ruvel(nx_real,ny_real,nz_real,nmodes))
       allocate(rvvel(nx_real,ny_real,nz_real,nmodes))


       allocate(ptemp(nx_real,ny_real,nz_real))
       allocate(psaln(nx_real,ny_real,nz_real))
       allocate(pdp(nx_real,ny_real,nz_real))
       allocate(puvel(nx_real,ny_real,nz_real))
       allocate(pvvel(nx_real,ny_real,nz_real))


       allocate(otemp(nx_real,ny_real,nz_real))
       allocate(osaln(nx_real,ny_real,nz_real))
       allocate(odp(nx_real,ny_real,nz_real))
       allocate(ouvel(nx_real,ny_real,nz_real))
       allocate(ovvel(nx_real,ny_real,nz_real))


       rtemp=0.0           
       rsaln=0.0
       rdp=0.0
       ruvel=0.0
       rvvel=0.0

       ptemp=0.0
       psaln=0.0
       pdp=0.0
       puvel=0.0
       pvvel=0.0



       do k=1,nz_real

       call xcaget(ouvel(:,:,k),u(1-nbdy,1-nbdy,k,lslot),1)
       call xcaget(ovvel(:,:,k),v(1-nbdy,1-nbdy,k,lslot),1)
       call xcaget(odp(:,:,k),dp(1-nbdy,1-nbdy,k,lslot),1)
       call xcaget(otemp(:,:,k),temp(1-nbdy,1-nbdy,k,lslot),1)      
       call xcaget(osaln(:,:,k),saln(1-nbdy,1-nbdy,k,lslot),1)

       enddo


      if     (mnproc.eq.1) then
      write (lp,*) 'restart_pc_in: ',pcflnm
      print *,"old value at test pt: ",
     & ouvel(257,1,1), ovvel(258,2,1),odp(257,1,1),otemp(257,1,1)

       
       open(15,file="uqruns")
       do i=1,nrlz
       READ(15,*) zeta(1),zeta(2)
       enddo
       close(15)

       print *, "Realization: ", nrlz 
       print *, "Stochastic Parameters: ", zeta
       print *, "No of Modes: 2"
c...   allocate all required arrays and form the data matrix
 

c...   data is 2 fields
      
       allocate (princomp(ntime,nmodes))
       princomp=0.0
!      read EOF
       call ncheck(nf90_open(trim(evecfile), nf90_Write, sncid))
       call ncheck(nf90_inq_varid(sncid, "rtemp", svarid))
       call ncheck(nf90_get_var(sncid,svarid,rtemp))

       call ncheck(nf90_inq_varid(sncid, "rsaln", svarid))
       call ncheck(nf90_get_var(sncid,svarid,rsaln))        

       call ncheck(nf90_inq_varid(sncid, "rdp", svarid))
       call ncheck(nf90_get_var(sncid,svarid,rdp))

       call ncheck(nf90_inq_varid(sncid, "ruvel", svarid))
       call ncheck(nf90_get_var(sncid,svarid,ruvel))

       call ncheck(nf90_inq_varid(sncid, "rvvel", svarid))
       call ncheck(nf90_get_var(sncid,svarid,rvvel))

!      read Princomp

       call ncheck(nf90_open(trim(pcflnm), nf90_Write, sncid))
       call ncheck(nf90_inq_varid(sncid, "pc", varid))
       call ncheck(nf90_get_var(sncid,varid,princomp))



         do k=1,nz_real
          do j=1,ny_real
           do i=1,nx_real 
              do l=1,nmodes
          ptemp(i,j,k)=ptemp(i,j,k)+
     &           real(rtemp(i,j,k,l))*princomp(1,l)*zeta(l)
          psaln(i,j,k)=psaln(i,j,k)+
     &           real(rsaln(i,j,k,l))*princomp(1,l)*zeta(l)
          pdp(i,j,k)=pdp(i,j,k)+
     &           real(rdp(i,j,k,l))*princomp(1,l)*zeta(l)
          puvel(i,j,k)=puvel(i,j,k)+
     &           real(ruvel(i,j,k,l))*princomp(1,l)*zeta(l)
          pvvel(i,j,k)=pvvel(i,j,k)+
     &           real(rvvel(i,j,k,l))*princomp(1,l)*zeta(l)
         enddo
         enddo
        enddo
        enddo

         do k=1,nz_real
         do j=1,ny_real
         do i=1,nx_real
          otemp(i,j,k) = otemp(i,j,k)+ptemp(i,j,k)
          osaln(i,j,k) = osaln(i,j,k)+psaln(i,j,k)
          odp(i,j,k)   = odp(i,j,k)+pdp(i,j,k)
          ouvel(i,j,k) = ouvel(i,j,k)!+0.001*puvel(i,j,k)
          ovvel(i,j,k) = ovvel(i,j,k)!+0.001*pvvel(i,j,k)
         enddo
        enddo
       enddo

       where(otemp > hspval) otemp=spval
       where(osaln > hspval) osaln=spval
       where(odp > hspval)   odp=spval
       where(ouvel > hspval) ouvel=spval
       where(ovvel > hspval) ovvel=spval



!        clean up dp's
        
        do j=1,ny_real
         do i=1,nx_real

! 1st pass

         do l = 1, nz_real-1
            k=l+1
            if(odp(i,j,k) .ne.spval) then
            odp(i,j,k)=odp(i,j,k)+min(0.0,odp(i,j,l))
            odp(i,j,k)=max(odp(i,j,k),0.0)
            endif
         end do

! 2nd pass

         do l = nz_real-1, 3, -1
             k=l+1
             if(odp(i,j,k) .ne. spval) then
            odp(i,j,k-1)=odp(i,j,k-1)+min(0.0,odp(i,j,k))
            odp(i,j,k)=max(odp(i,j,k),0.0)
             endif
         end do

         enddo
         enddo

!       end clean up dp's



        print *,"perturbed value at test pt: ",
     &  ouvel(257,1,1), ovvel(258,2,1),odp(257,1,1),
     &  otemp(257,1,1)
        
!        xxsum=0.0;xxsumi=0.0 
!        do k=1,nz_real
!        print *, k, opnest(257,1,k)/9806.! rdp(2,1,k)/9806.
!        xxsum=xxsum+opnest(257,1,k)/9806.
!        xxsumi=xxsumi+rdp(2,1,k)/9806.
!        enddo
!        print *, xxsum

       deallocate (princomp)

       endif !mnproc.eq.1

         do k=1,nz_real

       call xcaput(ouvel(:,:,k),u(1-nbdy,1-nbdy,k,lslot),1)
       call xcaput(ovvel(:,:,k),v(1-nbdy,1-nbdy,k,lslot),1)
       call xcaput(odp(:,:,k),dp(1-nbdy,1-nbdy,k,lslot),1)
       call xcaput(otemp(:,:,k),temp(1-nbdy,1-nbdy,k,lslot),1)
       call xcaput(osaln(:,:,k),saln(1-nbdy,1-nbdy,k,lslot),1)

       enddo

       deallocate(otemp)
       deallocate(osaln)
       deallocate(odp)
       deallocate(ouvel)
       deallocate(ovvel)

       deallocate(rtemp)
       deallocate(rsaln)
       deallocate(rdp)
       deallocate(ruvel)
       deallocate(rvvel)

       deallocate(ptemp)
       deallocate(psaln)
       deallocate(pdp)
       deallocate(puvel)
       deallocate(pvvel)

       end subroutine restart_pert
